#include <p30f6014a.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <e_uart_char.h>
#include <e_init_port.h>
#include <e_epuck_ports.h>
#include <e_simple_acc.h>
#include <btcom.h>


int main() {

	/*system initialization */
	e_init_port();
	e_init_uart1();
	e_init_simple_acc();

	/*Reset if Power on (some problem for few robots)*/
	if (RCONbits.POR) {
		RCONbits.POR=0;
		__asm__ volatile ("reset");
	}

	/* Wait for a command comming from bluetooth */
	/* Important issue when we are transmitting data and don't want
	 * the bluetooth stack stuck for programing mode */
	btcomWaitForCommand('s');

	/* X, Y and Z acceleration coordinates */
	static int acc_x, acc_y, acc_z;
	while(1){
		long i;
		/* Get acc data */
		e_get_simple_acc(&acc_x,&acc_y,&acc_z);

		/* DEBUG*/
		/* Send Acel */
		char tmp2[100];
		sprintf(tmp2," X: %d  Y: %d Z: %d", acc_x, acc_y, acc_z);
		btcomSendString(tmp2);
		btcomSendString("\n");
		/* DEBUG*/

		/* Small wait */
		for(i=0; i<100000; i++) { asm("nop"); }
	}
	return 0;
}
