#include <p30f6014a.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <e_uart_char.h>
#include <e_init_port.h>

int main() {

	/*system initialization */
	e_init_port();
	e_init_uart1();
	/* Ground sensors */
	e_init_ground_sensors();

	/*Reset if Power on (some problem for few robots)*/
	if (RCONbits.POR) {
		RCONbits.POR=0;
		__asm__ volatile ("reset");
	}

	/* Wait for a command comming from bluetooth */
	/* Important issue when we are transmitting data and don't want
	 * the bluetooth stack stuck for programing mode */
	btcomWaitForCommand('s');

	unsigned int ground_sensors[3];
	char tmp2[100];

	while(1){

		e_get_ground_sensors(ground_sensors);
		
		/* DEBUG*/
		/*Send Orientation */
		sprintf(tmp2,"%d %d %d",ground_sensors[0],ground_sensors[1],ground_sensors[2]);
		btcomSendString(tmp2);
		btcomSendString("\n");
		/* DEBUG*/

	}
	return 0;
}
