#include <p30f6014a.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <e_uart_char.h>
#include <e_init_port.h>
#include <e_prox.h>
#include <btcom.h>



int main() {

	/*system initialization */
	e_init_port();
	e_init_uart1();
	/* IR sensors */
	//e_init_simple_prox();
	e_init_prox();

	/*Reset if Power on (some problem for few robots)*/
	if (RCONbits.POR) {
		RCONbits.POR=0;
		__asm__ volatile ("reset");
	}

	int first_reading[8];
	int sensor_reading[8];

	int i;
	
	/* Wait for a command comming from bluetooth */
	/* Important issue when we are transmitting data and don't want
	 * the bluetooth stack stuck for programing mode */
	btcomWaitForCommand('s');

	/* Get the first reading to take ambient light */
	for(i=0; i < 8; i++){
		first_reading[i]=e_get_prox(i);
	}

	while(1){

		/* Get readings and substract the first reading */
		for(i=0; i < 8; i++){
			sensor_reading[i] = e_get_prox(i) - first_reading[i];
			if(sensor_reading[i] < 0) sensor_reading[i] = 0;
		}
		
		/* DEBUG*/
		/*Send Measures */
		char tmp2[100];

		sprintf(tmp2,"IR: %d %d %d %d %d %d %d %d ",
			sensor_reading[0],sensor_reading[1],sensor_reading[2],sensor_reading[3],
			sensor_reading[4],sensor_reading[5],sensor_reading[6],sensor_reading[7]);


		btcomSendString(tmp2);
		btcomSendString("\n");
		/* DEBUG*/

	}
	return 0;
}
