#include <p30f6014a.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include <e_uart_char.h>
#include <e_init_port.h>
#include <e_simple_prox.h>
#include <btcom.h>



int main() {

	/*system initialization */
	e_init_port();
	e_init_uart1();
	/* IR sensors */
  e_init_simple_prox();

	/*Reset if Power on (some problem for few robots)*/
	if (RCONbits.POR) {
		RCONbits.POR=0;
		__asm__ volatile ("reset");
	}

	int light_reading[8];

  int i;
	
	/* Wait for a command comming from bluetooth */
	/* Important issue when we are transmitting data and don't want
	 * the bluetooth stack stuck for programing mode */
	btcomWaitForCommand('s');

	while(1){

		/* Get readings and substract the first reading */
		for(i=0; i < 8; i++){
			light_reading[i] = e_get_simple_ambient_light(i);
		}
		
		/* DEBUG*/
		/*Send Measures */
		char tmp2[100];

		sprintf(tmp2,"LIGHT: %d %d %d %d %d %d %d %d",
			light_reading[0], light_reading[1], light_reading[2], light_reading[3],
			light_reading[4], light_reading[5], light_reading[6], light_reading[7]);


		btcomSendString(tmp2);
		btcomSendString("\n");
		/* DEBUG*/

	}
	return 0;
}
